## okteta 0.26.23+p24.04+vstable+git20260204.0904

=== debian/changelog ===
okteta (5:0.26.23+p24.04+vstable+git20260204.0904-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 04 Feb 2026 09:04:38 +0000

=== debian/control ===
Source: okteta
Section: kde
Priority: optional
Uploaders: Sune Vuorela <sune@debian.org>,
           Modestas Vainius <modax@debian.org>,
           George Kiagiadakis <kiagiadakis.george@gmail.com>,
           Maximiliano Curia <maxy@debian.org>
Build-Depends: cmake (>= 3.0~),
               debhelper-compat (= 13),
               extra-cmake-modules (>= 5.38.0~),
               libkf5bookmarks-dev (>= 5.38.0~),
               libkf5codecs-dev (>= 5.38.0~),
               libkf5completion-dev (>= 5.38.0~),
               libkf5configwidgets-dev (>= 5.38.0~),
               libkf5crash-dev (>= 5.38.0~),
               libkf5dbusaddons-dev (>= 5.38.0~),
               libkf5doctools-dev (>= 5.38.0~),
               libkf5i18n-dev (>= 5.38.0~),
               libkf5iconthemes-dev (>= 5.38.0~),
               libkf5kcmutils-dev (>= 5.38.0~),
               libkf5kio-dev (>= 5.38.0~),
               libkf5newstuff-dev (>= 5.38.0~),
               libkf5parts-dev (>= 5.38.0~),
               libkf5service-dev (>= 5.38.0~),
               libkf5widgetsaddons-dev (>= 5.38.0~),
               libkf5xmlgui-dev (>= 5.38.0~),
               libqca-qt5-2-dev (>= 2.1.0),
               pkg-config,
               pkg-kde-tools (>= 0.15.23~),
               qtbase5-dev (>= 5.9.0~),
               qtdeclarative5-dev (>= 5.9.0~),
               qtscript5-dev (>= 5.9.0~),
               qttools5-dev (>= 5.9.0~),
               shared-mime-info (>= 0.30),
               xauth,
               xvfb
Standards-Version: 4.6.2
Homepage: http://www.kde.org/
Vcs-Git: https://invent.kde.org/neon/extras/okteta.git
Vcs-Browser: https://invent.kde.org/neon/extras/okteta
Maintainer: Neon CI <neon@kde.org>

Package: libkasten4controllers0
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: controllers Kasten library for Okteta
 Kasten is a framework for composing programs.
 .
 This package provides the controller part of Kasten.
 .
 This package is part of the KDE Software Development Kit module.

Package: libkasten4core0
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libkasten3core3 (<< 5:0.26.0),
        libokteta-l10n (<< ${source:Version}~ciBuild),
        ${kde-l10n:all}
Replaces: libkasten3core3 (<< 5:0.26.0),
          libokteta-l10n (<< ${source:Version}~ciBuild),
          ${kde-l10n:all}
Description: core Kasten library for Okteta
 Kasten is a framework for composing programs.
 .
 This package provides the core part of Kasten.
 .
 This package is part of the KDE Software Development Kit module.

Package: libkasten3core3
Architecture: all
Depends: libkasten4core0, ${misc:Depends}
Description: transitional package
 transitional package which can be removed

Package: libkasten4gui0
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: gui Kasten library for Okteta
 Kasten is a framework for composing programs.
 .
 This package provides the GUI part of Kasten.
 .
 This package is part of the KDE Software Development Kit module.

Package: libkasten4okteta2controllers0
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: kastencontrollers library for Okteta
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 This package provides the part of the Okteta libraries interfacing with Kasten
 controllers.
 .
 This package is part of the KDE Software Development Kit module.

Package: libkasten4okteta2core0
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libkasten3okteta1core1 (<< 5:0.26.0),
        libokteta-l10n (<< ${source:Version}~ciBuild),
        ${kde-l10n:all}
Replaces: libkasten3okteta1core1 (<< 5:0.26.0),
          libokteta-l10n (<< ${source:Version}~ciBuild),
          ${kde-l10n:all}
Description: kastencore library for Okteta
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 This package provides the part of the Okteta libraries interfacing
 with Kasten core.
 .
 This package is part of the KDE Software Development Kit module.

Package: libkasten3okteta1core1
Architecture: all
Depends: libkasten4okteta2core0, ${misc:Depends}
Description: transitional package
 transitional package for libkasten4okteta2core0 which can be removed

Package: libkasten4okteta2gui0
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: kastengui library for Okteta
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 This package provides the part of the Okteta libraries interfacing
 with Kasten GUI.
 .
 This package is part of the KDE Software Development Kit module.

Package: libokteta3core0
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libokteta-l10n (<< ${source:Version}~ciBuild),
        libokteta2core2 (<< 5:0.26.0),
        ${kde-l10n:all}
Replaces: libokteta-l10n (<< ${source:Version}~ciBuild),
          libokteta2core2 (<< 5:0.26.0),
          ${kde-l10n:all}
Description: core Okteta library
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 This package provides the core part of the Okteta libraries.
 .
 This package is part of the KDE Software Development Kit module.

Package: libokteta2core2
Architecture: all
Depends: libokteta3core0, ${misc:Depends}
Description: transitional package
 Transitional package for libokteta3core0

Package: libokteta3gui0
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libokteta-l10n (<< ${source:Version}~ciBuild),
        libokteta2gui2 (<< 5:0.26.0),
        ${kde-l10n:all}
Replaces: libokteta-l10n (<< ${source:Version}~ciBuild),
          libokteta2gui2 (<< 5:0.26.0),
          ${kde-l10n:all}
Description: gui Okteta library
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 This package provides the GUI part of the Okteta libraries.
 .
 This package is part of the KDE Software Development Kit module.

Package: libokteta2gui2
Architecture: all
Depends: libokteta3gui0, ${misc:Depends}
Description: transitional package
 Transitional package for libokteta3gui0

Package: okteta
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: ${kde-l10n:all}
Replaces: ${kde-l10n:all}
Description: hexadecimal editor for binary files
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 The data is displayed in two variants: as the numeric values of the bytes
 and as the character assigned to the values. Values and characters can be
 shown either in two columns (the traditional display in hex editors) or in
 rows with the value on top of the character. Editing can be done both for
 the values and for the characters.
 .
 Besides the usual editing capabilities Okteta also brings a small set of
 tools, like a table listing decodings into common simple data types, a table
 listing all possible bytes with their character and value equivalents, an
 info view with a statistic, a checksum calculator, a filter tool and a string
 extraction tool.
 .
 This package is part of the KDE Software Development Kit module.

Package: okteta-dev
Architecture: any
Section: devel
Depends: libkf5kio-dev,
         libkf5xmlgui-dev (>= 5.38.0~),
         qtbase5-dev (>= 5.9~),
         ${misc:Depends},
         ${shlibs:Depends},
         ${so:Depends}
Breaks: okteta (<< 5:0.25.4)
Replaces: okteta (<< 5:0.25.4)
Description: Development files for Okteta
 Okteta is a simple editor for the raw data of files. This type of program is
 also called hexadecimal editor or binary editor.
 .
 This package contains the development files for Okteta.
 .
 This package is part of the KDE Software Development Kit module.

Package: libokteta-l10n
Architecture: all
Section: oldlibs
Priority: optional
Depends: libkasten4core0,
         libkasten4okteta2core0,
         libokteta3core0,
         libokteta3gui0,
         ${misc:Depends}
Description: transitional package
 Transitional package for libokteta4gui0

## okteta 0.26.23+p24.04+vunstable+git20251123.1238

=== libs/CMakeLists.txt ===
if( BUILD_OKTETAKASTENLIBS )
    add_subdirectory( kasten )
    add_subdirectory( framesprint )
endif()

=== core/tests/CMakeLists.txt ===
set(SUTDIR ${CMAKE_CURRENT_SOURCE_DIR}/..)

add_library(OktetaCoreSourcesTestShim INTERFACE)
target_include_directories(OktetaCoreSourcesTestShim INTERFACE
    ${SUTDIR}
    ${CMAKE_CURRENT_BINARY_DIR}/.. # for oktetacore_export.hpp
)
# Configure export macros to be setup as with a static lib
# as the source files are reused for the tests.
# Saves doing a separate export header.
target_compile_definitions(OktetaCoreSourcesTestShim INTERFACE
    -DOKTETACORE_STATICLIB
)

# helper
add_library(OktetaCoreTestUtil STATIC)
target_sources(OktetaCoreTestUtil PRIVATE
    util/fill.cpp
)
target_link_libraries(OktetaCoreTestUtil
    PUBLIC
        OktetaCore
        Qt6::Core
)

# variant for static version of OktetaCore
add_library(OktetaCoreSourcesShimTestUtil STATIC)
target_sources(OktetaCoreSourcesShimTestUtil PRIVATE
    util/fill.cpp
)
target_link_libraries(OktetaCoreSourcesShimTestUtil
    PUBLIC
      OktetaCoreSourcesTestShim
      Qt6::Core
)

ecm_add_test(
    arraychangemetricstest.cpp
    #  ${CMAKE_CURRENT_SOURCE_DIR}/../arraychangemetrics.cpp
    TEST_NAME arraychangemetricstest
    NAME_PREFIX libokteta-core-
    LINK_LIBRARIES
        OktetaCoreSourcesTestShim
        Qt6::Test
)


ecm_add_test(
    addressrangetest.cpp
    TEST_NAME addressrangetest
    NAME_PREFIX libokteta-core-
    LINK_LIBRARIES
        OktetaCoreTypes
        Qt6::Test
)


ecm_add_test(
    addressrangelisttest.cpp
    TEST_NAME addressrangelisttest
    NAME_PREFIX libokteta-core-
    LINK_LIBRARIES
        OktetaCoreTypes
        Qt6::Core5Compat
        Qt6::Test
)


ecm_add_test(
    fixedsizebytearraymodeltest.cpp
    TEST_NAME fixedsizebytearraymodeltest
    NAME_PREFIX libokteta-core-
    LINK_LIBRARIES
        OktetaCoreByteArrayModels
        Qt6::Test
)


ecm_add_test(
    abstractbytearraymodeliftest.cpp
    fixedsizebytearraymodelabstractbytearraymodeliftest.cpp
    TEST_NAME fixedsizebytearraymodelabstractbytearraymodeliftest
    NAME_PREFIX libokteta-core-
    LINK_LIBRARIES
        OktetaCoreSourcesShimTestUtil
        OktetaCoreByteArrayModels
        Qt6::Test
)


ecm_add_test(
    bytearraymodeltest.cpp
    TEST_NAME bytearraymodeltest
    NAME_PREFIX libokteta-core-
    LINK_LIBRARIES
        OktetaCore
        Qt6::Test
)


ecm_add_test(
    abstractbytearraymodeliftest.cpp
    bytearraymodelabstractbytearraymodeliftest.cpp
    TEST_NAME bytearraymodelabstractbytearraymodeliftest
    NAME_PREFIX libokteta-core-
    LINK_LIBRARIES
        OktetaCoreSourcesShimTestUtil
        OktetaCoreByteArrayModels
        Qt6::Test
)


ecm_add_test(
    abstractbytearraymodeliftest.cpp
    piecetablebytearraymodelabstractbytearraymodeliftest.cpp
    TEST_NAME piecetablebytearraymodelabstractbytearraymodeliftest
    NAME_PREFIX libokteta-core-
    LINK_LIBRARIES
        OktetaCoreSourcesShimTestUtil
        OktetaCoreByteArrayModels
        Qt6::Test
)


ecm_add_test(
    versionableiftest.cpp
    piecetablebytearraymodelversionableiftest.cpp
    TEST_NAME piecetablebytearraymodelversionableiftest
    NAME_PREFIX libokteta-core-
    LINK_LIBRARIES
        OktetaCoreTestUtil
        OktetaCore
        Qt6::Test
)


ecm_add_test(
    valuecodectest.cpp
    TEST_NAME valuecodectest
    NAME_PREFIX libokteta-core-
    LINK_LIBRARIES
        OktetaCoreValueCodecs
        Qt6::Test
)


ecm_add_test(
    charcodectest.cpp
    TEST_NAME charcodectest
    NAME_PREFIX libokteta-core-
    LINK_LIBRARIES
        OktetaCoreCharCodecs
        Qt6::Test
)


ecm_add_test(
    textcharcodectest.cpp
    TEST_NAME textcharcodectest
    NAME_PREFIX libokteta-core-
    LINK_LIBRARIES
        OktetaCoreCharCodecs
        Qt6::Test
)


ecm_add_test(
    charcodeciftest.cpp
    textcharcodeccharcodeciftest.cpp
    TEST_NAME textcharcodeccharcodeciftest
    NAME_PREFIX libokteta-core-
    LINK_LIBRARIES
        OktetaCoreCharCodecs
        Qt6::Test
)


ecm_add_test(
    charcodeciftest.cpp
    ebcdic1047charcodeccharcodeciftest.cpp
    TEST_NAME ebcdic1047charcodeccharcodeciftest
    NAME_PREFIX libokteta-core-
    LINK_LIBRARIES
        OktetaCoreCharCodecs
        Qt6::Test
)


ecm_add_test(
    bookmarktest.cpp
    TEST_NAME bookmarktest
    NAME_PREFIX libokteta-core-
    LINK_LIBRARIES
        OktetaCoreSourcesTestShim
        Qt6::Test
)


ecm_add_test(
    bookmarklisttest.cpp
    TEST_NAME bookmarklisttest
    NAME_PREFIX libokteta-core-
    LINK_LIBRARIES
        OktetaCoreBookmark
        Qt6::Test
)

=== kasten/gui/CMakeLists.txt ===
set(OKTETAKASTENGUI_VERSION ${OKTETAKASTEN_LIB_VERSION})
set(OKTETAKASTENGUI_SO_VERSION ${OKTETAKASTEN_LIB_SOVERSION})

okteta_add_library(Gui NAMESPACE Okteta Kasten
    PUBLIC
        OktetaKastenCore
        KastenGui
        OktetaGui
    PRIVATE
        KF6::Completion
        KF6::I18n
    VERSION     ${OKTETAKASTENGUI_VERSION}
    SOVERSION   ${OKTETAKASTENGUI_SO_VERSION}
    ABIVERSION  ${OKTETAKASTEN_ABI_VERSION} ${KASTEN_ABI_VERSION}
    NO_VERSIONED_INCLUDEDIR
    REVERSE_NAMESPACE_INCLUDEDIR
    REVERSE_NAMESPACE_LIB
    NO_TARGET_NAMESPACE
    KI18N_TRANSLATION_DOMAIN "liboktetakasten"
)

ecm_qt_declare_logging_category(OktetaKastenGui
    HEADER "logging.hpp"
    IDENTIFIER "LOG_KASTEN_OKTETA_GUI"
    CATEGORY_NAME "kasten.okteta.gui"
    DESCRIPTION "Kasten Okteta Gui module"
    EXPORT OKTETA
)

macro(OKTETAKASTENGUI_SOURCES)
    okteta_library_sources(Gui NAMESPACE Okteta Kasten
        REVERSE_NAMESPACE_INCLUDEDIR
        ${ARGN}
    )
endmacro()

macro(OKTETAKASTENGUI_ADD_SUBLIBRARY _library_name)
    okteta_add_sublibrary(Gui NAMESPACE Okteta Kasten
        SUBLIBRARY ${_library_name}
        ${ARGN}
    )
endmacro()

macro(OKTETAKASTENGUI_SUBLIBRARY_SOURCES _library_name)
    okteta_sublibrary_sources(Gui NAMESPACE Okteta Kasten
        REVERSE_NAMESPACE_INCLUDEDIR
        SUBLIBRARY ${_library_name}
        ${ARGN}
    )
endmacro()

oktetakastengui_add_sublibrary(OktetaKastenGuiWidgets
    UNTESTED
    PUBLIC
        OktetaCore
        Qt6::Widgets
    PRIVATE
        KF6::Completion
        KF6::I18n
        Qt6::Qml
    KI18N_TRANSLATION_DOMAIN "liboktetakasten"
)

oktetakastengui_sublibrary_sources(OktetaKastenGuiWidgets
    SUBDIR liboktetawidgets
    BUILD_INCLUDEDIR
    PUBLIC
        AddressComboBox
        ByteArrayComboBox
    PRIVATE
        AddressValidator
        AbstractByteArrayStringValidator
        ByteArrayChar8StringDecoder
        ByteArrayChar8StringEncoder
        ByteArrayChar8StringValidator
        ByteArrayUtf8StringDecoder
        ByteArrayUtf8StringEncoder
        ByteArrayUtf8StringValidator
        ByteArrayValidator
        ByteArrayValueStringValidator
)

oktetakastengui_add_sublibrary(OktetaKastenGuiView
    UNTESTED
    PUBLIC
        OktetaKastenCore
        KastenGui
        OktetaGui
    PRIVATE
        KF6::I18n
    KI18N_TRANSLATION_DOMAIN "liboktetakasten"
)

oktetakastengui_sublibrary_sources(OktetaKastenGuiView
    SUBDIR view
    BUILD_INCLUDEDIR
    PUBLIC
        ByteArrayView
        ByteArrayViewFactory
        ByteArrayViewProfile
    PRIVATE
        ByteArrayJanusview
        UserMessagesOverlayLayout
        UserMessagesOverlayedWidget
)

oktetakastengui_sublibrary_sources(OktetaKastenGuiView
    SUBDIR system
    BUILD_INCLUDEDIR
    PUBLIC
        ByteArrayViewProfileLock
        ByteArrayViewProfileManager
)

oktetakastengui_sublibrary_sources(OktetaKastenGuiView
    SUBDIR io
    BUILD_INCLUDEDIR
    PUBLIC
        ByteArrayViewProfileSynchronizer
)


oktetakastengui_add_sublibrary(OktetaKastenGuiStreamEncoder
    UNTESTED
    PUBLIC
        OktetaKastenCore
        KastenGui
        OktetaGui
    PRIVATE
        OktetaKastenGuiWidgets
        OktetaKastenGuiView
        KF6::Completion
        KF6::I18n
        BZip2::BZip2
        LibLZMA::LibLZMA
        ZLIB::ZLIB
        zstd::libzstd
    KI18N_TRANSLATION_DOMAIN "liboktetakasten"
)

macro(OKTETAKASTENGUI_STREAMENCODER_SOURCES)
    okteta_sublibrary_sources(Gui NAMESPACE Okteta Kasten
        REVERSE_NAMESPACE_INCLUDEDIR
        SUBLIBRARY OktetaKastenGuiStreamEncoder
        ${ARGN}
    )
endmacro()

macro(OKTETAKASTENGUI_STREAMCOMPRESSOR_SOURCES)
    # for now handle as stream encoders
    oktetakastengui_streamencoder_sources(
        ${ARGN}
    )
endmacro()

oktetakastengui_streamencoder_sources(
    SUBDIR io/streamencoder/values
    PRIVATE
        ByteArrayValuesStreamEncoderConfigEditor
        ByteArrayValuesStreamEncoderConfigEditorFactory
        ByteArrayValuesStreamEncoder
)

oktetakastengui_streamencoder_sources(
    SUBDIR io/streamencoder/base32
    PRIVATE
        ByteArrayBase32StreamEncoderConfigEditor
        ByteArrayBase32StreamEncoderConfigEditorFactory
        ByteArrayBase32StreamEncoder
)

oktetakastengui_streamencoder_sources(
    SUBDIR io/streamencoder/uuencoding
    PRIVATE
        ByteArrayUuencodingStreamEncoderConfigEditor
        ByteArrayUuencodingStreamEncoderConfigEditorFactory
        ByteArrayUuencodingStreamEncoder
)

oktetakastengui_streamencoder_sources(
    SUBDIR io/streamencoder/xxencoding
    PRIVATE
        ByteArrayXxencodingStreamEncoderConfigEditor
        ByteArrayXxencodingStreamEncoderConfigEditorFactory
        ByteArrayXxencodingStreamEncoder
)

oktetakastengui_streamencoder_sources(
    SUBDIR io/streamencoder/sourcecode
    PRIVATE
        ByteArraySourceCodeStreamEncoderConfigEditor
        ByteArraySourceCodeStreamEncoderConfigEditorFactory
        ByteArraySourceCodeStreamEncoder
)

oktetakastengui_streamencoder_sources(
    SUBDIR io/streamencoder/srec
    PRIVATE
        ByteArraySRecStreamEncoderConfigEditor
        ByteArraySRecStreamEncoderConfigEditorFactory
        ByteArraySRecStreamEncoder
)

oktetakastengui_streamencoder_sources(
    SUBDIR io/streamencoder/ihex
    PRIVATE
        ByteArrayIHexStreamEncoderConfigEditor
        ByteArrayIHexStreamEncoderConfigEditorFactory
        ByteArrayIHexStreamEncoder
)

oktetakastengui_streamencoder_sources(
    SUBDIR io/streamencoder/viewhtml
    PRIVATE
        AbstractColumnHtmlRenderer
        OffsetColumnHtmlRenderer
        AbstractByteArrayColumnHtmlRenderer
        ValueByteArrayColumnHtmlRenderer
        CharByteArrayColumnHtmlRenderer
        ByteArrayRowsColumnHtmlRenderer
        ByteArrayViewHtmlStreamEncoder
)

oktetakastengui_streamencoder_sources(
    SUBDIR io/streamencoder/viewtext
    PRIVATE
        AbstractColumnTextRenderer
        OffsetColumnTextRenderer
        BorderColumnTextRenderer
        AbstractByteArrayColumnTextRenderer
        ValueByteArrayColumnTextRenderer
        CharByteArrayColumnTextRenderer
        ByteArrayRowsColumnTextRenderer
        ByteArrayViewTextStreamEncoder
)

oktetakastengui_streamencoder_sources(
    SUBDIR io/streamencoder/chars
    PRIVATE
        ByteArrayCharsStreamEncoderConfigEditor
        ByteArrayCharsStreamEncoderConfigEditorFactory
        ByteArrayCharsStreamEncoder
)
oktetakastengui_streamencoder_sources(
    SUBDIR io/streamencoder/base64
    PRIVATE
        ByteArrayBase64StreamEncoder
)
oktetakastengui_streamencoder_sources(
    SUBDIR io/streamencoder/base85
    PRIVATE
        ByteArrayBase85StreamEncoder
)

oktetakastengui_streamcompressor_sources(
    SUBDIR io/streamcompressor/bzip2
    PRIVATE
        ByteArrayBZip2StreamCompressorConfigEditor
        ByteArrayBZip2StreamCompressorConfigEditorFactory
        ByteArrayBZip2StreamCompressor
        BZip2CompressionStream
)

oktetakastengui_streamcompressor_sources(
    SUBDIR io/streamcompressor/deflate
    PRIVATE
        ByteArrayDeflateStreamCompressorConfigEditor
        ByteArrayDeflateStreamCompressorConfigEditorFactory
        ByteArrayDeflateStreamCompressor
        DeflateCompressionStream
)

oktetakastengui_streamcompressor_sources(
    SUBDIR io/streamcompressor/gzip
    PRIVATE
        ByteArrayGZipStreamCompressorConfigEditor
        ByteArrayGZipStreamCompressorConfigEditorFactory
        ByteArrayGZipStreamCompressor
        GZipCompressionStream
        Iso8859_1StringValidator
)

oktetakastengui_streamcompressor_sources(
    SUBDIR io/streamcompressor/xz
    PRIVATE
        ByteArrayXzStreamCompressorConfigEditor
        ByteArrayXzStreamCompressorConfigEditorFactory
        ByteArrayXzStreamCompressor
        XzCompressionStream
)

oktetakastengui_streamcompressor_sources(
    SUBDIR io/streamcompressor/zstd
    PRIVATE
        ByteArrayZStdStreamCompressorConfigEditor
        ByteArrayZStdStreamCompressorConfigEditorFactory
        ByteArrayZStdStreamCompressor
        ZStdCompressionStream
)

oktetakastengui_streamcompressor_sources(
    SUBDIR io/streamcompressor
    BUILD_INCLUDEDIR
    PRIVATE
        AbstractByteArrayOutput
        IoDeviceByteArrayOutput
        AbstractCompressionStream
        AbstractByteArrayStreamCompressor
)

oktetakastengui_streamencoder_sources(
    SUBDIR io/streamencoder
    BUILD_INCLUDEDIR
    PUBLIC
        AbstractByteArrayStreamEncoder
    PRIVATE
        ByteArrayTextStreamEncoderPreview
)

oktetakastengui_streamencoder_sources(
    SUBDIR io
    BUILD_INCLUDEDIR
    PUBLIC
        ByteArrayStreamEncoderFactory
        ByteArrayStreamEncoderConfigEditorFactoryFactory
)

oktetakastengui_add_sublibrary(OktetaKastenGuiGenerator
    UNTESTED
    PUBLIC
        OktetaKastenCore
        KastenGui
        OktetaGui
    PRIVATE
        OktetaKastenGuiWidgets
        OktetaKastenGuiView
        KF6::Completion
        KF6::I18n
    KI18N_TRANSLATION_DOMAIN "liboktetakasten"
)

macro(OKTETAKASTENGUI_GENERATOR_SOURCES)
    okteta_sublibrary_sources(Gui NAMESPACE Okteta Kasten
        REVERSE_NAMESPACE_INCLUDEDIR
        SUBLIBRARY OktetaKastenGuiGenerator
        ${ARGN}
    )
endmacro()

oktetakastengui_generator_sources(
    SUBDIR io/generator/pattern
    PRIVATE
        ByteArrayPatternGeneratorconfigEditor
        ByteArrayPatternGeneratorconfigEditorFactory
        ByteArrayPatternGenerator
)

oktetakastengui_generator_sources(
    SUBDIR io/generator/randomdata
    PRIVATE
        ByteArrayRandomDataGeneratorconfigEditor
        ByteArrayRandomDataGeneratorconfigEditorFactory
        ByteArrayRandomDataGenerator
)

oktetakastengui_generator_sources(
    SUBDIR io/generator/sequence
    PRIVATE
        ByteArraySequenceGenerator
)

oktetakastengui_generator_sources(
    SUBDIR io
    BUILD_INCLUDEDIR
    PUBLIC
        ByteArrayDataGeneratorFactory
        ByteArrayDataGeneratorConfigEditorFactoryFactory
)


oktetakastengui_sources(
    PUBLIC
        OktetaKastenGui
)

okteta_add_cmakeconfig(Gui NAMESPACE Okteta Kasten
    DEPS
        OktetaKastenCore
        KastenGui
        OktetaGui
)

if(BUILD_TESTING)
    add_subdirectory(liboktetawidgets/tests)
endif()

=== parts/kpart/tests/CMakeLists.txt ===
set(SUTDIR ${CMAKE_CURRENT_SOURCE_DIR}/..)

configure_file(oktetaparttest-config.hpp.in ${CMAKE_CURRENT_BINARY_DIR}/oktetaparttest-config.hpp @ONLY)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/../oktetapart.json.in oktetapart.json @ONLY)

# TODO: deduplicate object file generation of
ecm_add_test(
    ${SUTDIR}/part.cpp
    ${SUTDIR}/navigationextension.cpp
    ${SUTDIR}/partfactory.cpp
    oktetaparttest.cpp

    TEST_NAME oktetaparttest
    NAME_PREFIX kpart-
    LINK_LIBRARIES
      OktetaKastenControllers
      OktetaKastenGui
      OktetaKastenCore
      KastenControllers
      KastenGui
      KastenCore
      KF6::I18n
      KF6::Parts
      Qt6::Test
)

target_include_directories(oktetaparttest PRIVATE
    ${SUTDIR}
    ${CMAKE_CURRENT_BINARY_DIR}/..
)

target_compile_definitions(oktetaparttest PRIVATE TRANSLATION_DOMAIN=\"oktetapart\")

=== kasten/core/document/tests/CMakeLists.txt ===
set( SUTDIR ${CMAKE_CURRENT_SOURCE_DIR}/.. )
set(LIBOKTETAWIDGETS_REL_DIR ../../../gui/liboktetawidgets)

add_library(OktetaKastenCoreDocumentSourcesTestShim INTERFACE)
target_include_directories(OktetaKastenCoreDocumentSourcesTestShim INTERFACE
    ${CMAKE_CURRENT_BINARY_DIR}/../..
    ${SUTDIR}
    ${SUTDIR}/..
)
# Configure export macros to be setup as with a static lib
# as the source files are reused for the tests.
# Saves doing a separate export header.
target_compile_definitions(OktetaKastenCoreDocumentSourcesTestShim INTERFACE
    -DOKTETAKASTENCORE_STATICLIB
)

########### bytearraydocumenttest ###############

ecm_add_test(
    bytearraydocumenttest.cpp
    ${SUTDIR}/bytearraydocument.cpp
    TEST_NAME bytearraydocumenttest
    NAME_PREFIX oktetakasten-core-document-
    LINK_LIBRARIES
        OktetaKastenCoreDocumentSourcesTestShim
        KastenCore
        OktetaCore
        KF6::I18n
        Qt6::Test
)
target_compile_definitions(bytearraydocumenttest PRIVATE -DTRANSLATION_DOMAIN=\"liboktetakasten\")


########### bytearraydocumentfactorytest ###############

ecm_add_test(
    bytearraydocumentfactorytest.cpp
    ${SUTDIR}/bytearraydocument.cpp
    ${SUTDIR}/bytearraydocumentfactory.cpp
    ${LIBOKTETAWIDGETS_REL_DIR}/bytearraychar8stringdecoder.cpp
    ${LIBOKTETAWIDGETS_REL_DIR}/bytearrayvaluestringdecoder.cpp
    TEST_NAME bytearraydocumentfactorytest
    NAME_PREFIX oktetakasten-core-document-
    LINK_LIBRARIES
        OktetaKastenCoreDocumentSourcesTestShim
        KastenCore
        OktetaCoreSourcesShimTestUtil
        OktetaCoreByteArrayModels
        OktetaCoreCharCodecs
        OktetaCoreValueCodecs
        KF6::I18n
        Qt6::Test
)
target_compile_definitions(bytearraydocumentfactorytest PRIVATE -DTRANSLATION_DOMAIN=\"liboktetakasten\")
target_include_directories(bytearraydocumentfactorytest
    PRIVATE
        ${LIBOKTETAWIDGETS_REL_DIR}
)

=== kasten/core/io/tests/CMakeLists.txt ===
set( SUTDIR ${CMAKE_CURRENT_SOURCE_DIR}/.. )

add_library(OktetaKastenCoreIoSut STATIC)
target_sources(OktetaKastenCoreIoSut
    PRIVATE
        ${SUTDIR}/filesystem/bytearrayrawfileloadthread.cpp
        ${SUTDIR}/filesystem/bytearrayrawfilereloadthread.cpp
        ${SUTDIR}/filesystem/bytearrayrawfilewritethread.cpp
        ${SUTDIR}/filesystem/bytearrayrawfileloadjob.cpp
        ${SUTDIR}/filesystem/bytearrayrawfileconnectjob.cpp
        ${SUTDIR}/filesystem/bytearrayrawfilewritejob.cpp
        ${SUTDIR}/filesystem/bytearrayrawfilereloadjob.cpp
        ${SUTDIR}/filesystem/bytearrayrawfilewritetojob.cpp
)
target_link_libraries(OktetaKastenCoreIoSut
    PUBLIC
        KastenCore
        OktetaCore
    PRIVATE
        KF6::I18n
        KF6::CoreAddons
)
target_include_directories(OktetaKastenCoreIoSut PUBLIC
    ${CMAKE_CURRENT_BINARY_DIR}/../..
    ${SUTDIR}
    ${SUTDIR}/..
    ${SUTDIR}/../document
    ${SUTDIR}/filesystem
)
# Configure export macros to be setup as with a static lib
# as the source files are reused for static OktetaKastenCoreIoSut
# Saves doing a separate export header.
target_compile_definitions(OktetaKastenCoreIoSut
    PUBLIC
        OKTETAKASTENCORE_STATICLIB
    PRIVATE
        TRANSLATION_DOMAIN=\"liboktetakasten\"
)

########### bytearrayrawfilesynchronizertest ###############

ecm_add_test(
    bytearrayrawfilesynchronizertest.cpp
    ${SUTDIR}/../document/bytearraydocument.cpp
    ${SUTDIR}/filesystem/bytearrayrawfilesynchronizer.cpp
    ${SUTDIR}/filesystem/externalbookmarkstorage.cpp
    TEST_NAME bytearrayrawfilesynchronizertest
    NAME_PREFIX oktetakasten-core-io-
    LINK_LIBRARIES
        OktetaKastenCoreIoSut
        KastenCoreTestUtil
        KastenCore
        OktetaCoreTestUtil
        KF6::I18n
        KF6::Bookmarks
        Qt6::Test
)
target_compile_definitions(bytearrayrawfilesynchronizertest PRIVATE -DTRANSLATION_DOMAIN=\"liboktetakasten\")

########### bytearrayrawfilesynchronizerfactorytest ###############

ecm_add_test(
    bytearrayrawfilesynchronizerfactorytest.cpp
    ${SUTDIR}/../document/bytearraydocument.cpp
    ${SUTDIR}/filesystem/externalbookmarkstorage.cpp
    ${SUTDIR}/filesystem/bytearrayrawfilesynchronizer.cpp
    ${SUTDIR}/filesystem/bytearrayrawfilesynchronizerfactory.cpp
    TEST_NAME bytearrayrawfilesynchronizerfactorytest
    NAME_PREFIX oktetakasten-core-io-
    LINK_LIBRARIES
        OktetaKastenCoreIoSut
        KastenCoreTestUtil
        KastenCore
        OktetaCoreTestUtil
        KF6::I18n
        KF6::Bookmarks
        Qt6::Test
)
target_compile_definitions(bytearrayrawfilesynchronizerfactorytest PRIVATE -DTRANSLATION_DOMAIN=\"liboktetakasten\")

=== kasten/gui/liboktetawidgets/tests/CMakeLists.txt ===
set(SUTDIR ${CMAKE_CURRENT_SOURCE_DIR}/..)

add_library(OktetaWidgetsSourcesTestShim INTERFACE)
target_include_directories(OktetaWidgetsSourcesTestShim INTERFACE
    ${SUTDIR}
    ${CMAKE_CURRENT_BINARY_DIR}/../..
)
# Configure export macros to be setup as with a static lib
# as the source files are reused for the tests.
# Saves doing a separate export header.
target_compile_definitions(OktetaWidgetsSourcesTestShim INTERFACE
    -DOKTETAKASTENGUI_STATICLIB
)

ecm_add_test(
    bytearraychar8stringencodertest.cpp
    ${SUTDIR}/bytearraychar8stringencoder.cpp
    TEST_NAME bytearraychar8stringencodertest
    NAME_PREFIX oktetakasten-oktetawidgets-
    LINK_LIBRARIES
        OktetaWidgetsSourcesTestShim
        OktetaCoreCharCodecs
        Qt6::Core5Compat
        Qt6::Test
)

ecm_add_test(
    bytearraychar8stringdecodertest.cpp
    ${SUTDIR}/bytearraychar8stringdecoder.cpp
    TEST_NAME bytearraychar8stringdecodertest
    NAME_PREFIX oktetakasten-oktetawidgets-
    LINK_LIBRARIES
        OktetaWidgetsSourcesTestShim
        OktetaCoreCharCodecs
        Qt6::Core5Compat
        Qt6::Test
)

ecm_add_test(
    bytearraychar8stringcodecroundtriptest.cpp
    ${SUTDIR}/bytearraychar8stringdecoder.cpp
    ${SUTDIR}/bytearraychar8stringencoder.cpp
    TEST_NAME bytearraychar8stringcodecroundtriptest
    NAME_PREFIX oktetakasten-oktetawidgets-
    LINK_LIBRARIES
        OktetaWidgetsSourcesTestShim
        OktetaCoreCharCodecs
        Qt6::Core5Compat
        Qt6::Test
)

ecm_add_test(
    bytearrayutf8stringencodertest.cpp
    ${SUTDIR}/bytearrayutf8stringencoder.cpp
    TEST_NAME bytearrayutf8stringencodertest
    NAME_PREFIX oktetakasten-oktetawidgets-
    LINK_LIBRARIES
        OktetaWidgetsSourcesTestShim
        OktetaCoreCharCodecs
        Qt6::Core5Compat
        Qt6::Test
)

ecm_add_test(
    bytearrayutf8stringdecodertest.cpp
    ${SUTDIR}/bytearrayutf8stringdecoder.cpp
    TEST_NAME bytearrayutf8stringdecodertest
    NAME_PREFIX oktetakasten-oktetawidgets-
    LINK_LIBRARIES
        OktetaWidgetsSourcesTestShim
        OktetaCoreCharCodecs
        Qt6::Core5Compat
        Qt6::Test
)

ecm_add_test(
    bytearrayvaluestringdecodertest.cpp
    ${SUTDIR}/bytearrayvaluestringdecoder.cpp
    TEST_NAME bytearrayvaluestringdecodertest
    NAME_PREFIX oktetakasten-oktetawidgets-
    LINK_LIBRARIES
        OktetaWidgetsSourcesTestShim
        OktetaCoreValueCodecs
        Qt6::Test
)

ecm_add_test(
    bytearrayvalidatortest.cpp
    ${SUTDIR}/bytearraychar8stringdecoder.cpp
    ${SUTDIR}/bytearraychar8stringencoder.cpp
    ${SUTDIR}/bytearraychar8stringvalidator.cpp
    ${SUTDIR}/bytearrayutf8stringdecoder.cpp
    ${SUTDIR}/bytearrayutf8stringencoder.cpp
    ${SUTDIR}/bytearrayutf8stringvalidator.cpp
    ${SUTDIR}/bytearrayvaluestringvalidator.cpp
    ${SUTDIR}/bytearrayvalidator.cpp
    TEST_NAME bytearrayvalidatortest
    NAME_PREFIX oktetakasten-oktetawidgets-
    LINK_LIBRARIES
        OktetaWidgetsSourcesTestShim
        OktetaCoreCharCodecs
        OktetaCoreValueCodecs
        Qt6::Gui
        Qt6::Core5Compat
        Qt6::Test
)

=== kasten/controllers/view/search/tests/CMakeLists.txt ===
set(SUTDIR ${CMAKE_CURRENT_SOURCE_DIR}/..)

ecm_add_test(
    ${SUTDIR}/searchtool.cpp
    searchtooltest.cpp

    TEST_NAME searchtooltest
    NAME_PREFIX oktetakasten-controllers-search-
    LINK_LIBRARIES
        OktetaKastenControllersConfigEntries
        OktetaKastenControllersByteArraySearch
        OktetaKastenGui
        OktetaKastenCore
        KF6::I18n
        Qt6::Test
)
target_include_directories(searchtooltest
    PUBLIC
        ${SUTDIR}
)
target_compile_definitions(searchtooltest PRIVATE -DTRANSLATION_DOMAIN=\"liboktetakasten\")
